<sqtm-core-entity-view-wrapper [sqtmCoreViewId]="getViewId()">
  @if (componentData$ | async; as componentData) {
    @if (referentialData$ | async; as referentialData) {
      <div class="flex full-height full-width neutral-background-color">
        <div class="flex-column full-width">
          <sqtm-core-entity-view-header
            class="full-width content-head p-t-10 p-r-20"
            [nameEditable]="isNameEditable(componentData)"
            [attachmentList]="componentData.requirementVersion.attachmentList"
            [entityPath]="componentData.requirementVersion.path"
            (attachmentBadgeClickEvent)="toggleAttachmentPanel()"
          >
            <div projection="actions" class="flex-column full-height width-40">
              <ng-content></ng-content>
            </div>
            <div projection="reference" class="reference">
              <sqtm-core-editable-text-field
                [attr.data-test-field-id]="'entity-reference'"
                [sqtmCoreEntityViewEditableTextField]="'reference'"
                ngDefaultControl
                [layout]="'compact'"
                [editable]="
                  allowRequirementModification(
                    componentData.requirementVersion.status
                  )
                "
                placeholder="{{
                  'sqtm-core.requirement-workspace.reference.placeholder'
                    | translate
                }}"
                [trimValue]="true"
              >
              </sqtm-core-editable-text-field>
            </div>
            <div
              projection="notifications"
              class="m-r-40"
              [attr.data-test-element-id]="'notifications'"
            >
              @if (!componentData.milestonesAllowModification) {
                <div
                  [attr.data-test-element-id]="'milestone-locked-warning'"
                  nz-tooltip
                  [nzTooltipTitle]="lockedMilestoneMessage"
                  [nzTooltipPlacement]="'bottom'"
                  class="font-20-px sqtm-core-error-message"
                >
                  <i
                    nz-icon
                    nzType="sqtm-core-nav:milestone"
                    nzTheme="outline"
                  ></i>
                </div>
              }
            </div>
            @if (this.showActionMenu(componentData, referentialData)) {
              <div
                projection="menu"
                [attr.data-test-toolbar-button-id]="'action-menu-button'"
              >
                <span
                  class="font-20-px"
                  nz-dropdown
                  [nzDropdownMenu]="actionMenu"
                  [nzPlacement]="'bottomCenter'"
                >
                  <i
                    nz-icon
                    nzType="sqtm-core-generic:more"
                    nzTheme="outline"
                    class="current-workspace-button"
                  ></i>
                </span>
              </div>
            }

            <div projection="capsule" class="sqtm-core-capsules-container">
              <sqtm-core-capsule-information
                [informationData]="
                  getRequirementStatusInformationData(
                    componentData.requirementVersion.status
                  )
                "
                [editable]="
                  componentData.permissions.canWrite &&
                  componentData.milestonesAllowModification
                "
                [listPanelItems]="this.statusItems"
                [selectedItem]="componentData.requirementVersion.status"
                [attr.data-test-capsule-id]="'status'"
                (itemSelectionChanged)="updateRequirementStatus($event)"
              >
              </sqtm-core-capsule-information>
              <sqtm-core-capsule-information
                [informationData]="
                  getRequirementCriticalityInformationData(
                    componentData.requirementVersion.criticality
                  )
                "
                [editable]="
                  allowRequirementModifications(componentData) &&
                  componentData.permissions.canWrite
                "
                [listPanelItems]="this.criticalityItems"
                [selectedItem]="componentData.requirementVersion.criticality"
                [attr.data-test-capsule-id]="'criticality'"
                (itemSelectionChanged)="updateRequirementCriticality($event)"
              >
              </sqtm-core-capsule-information>
              @if (
                this.referentialDataService.milestoneModeData$ | async;
                as milestoneState
              ) {
                @if (
                  isSynchronized(componentData) ||
                  !allowNavigationToVersion(milestoneState)
                ) {
                  <sqtm-core-capsule-information
                    [informationData]="
                      getRequirementVersionNumberInformationData(
                        componentData.requirementVersion.versionNumber
                      )
                    "
                  >
                  </sqtm-core-capsule-information>
                } @else {
                  <a
                    class="text-decoration-none"
                    [routerLink]="[
                      '/',
                      'requirement-workspace',
                      'requirement',
                      componentData.requirementVersion.requirementId,
                      'version'
                    ]"
                  >
                    <sqtm-core-capsule-information
                      [informationData]="
                        getRequirementVersionNumberInformationData(
                          componentData.requirementVersion.versionNumber
                        )
                      "
                    >
                    </sqtm-core-capsule-information>
                  </a>
                }
              }
            </div>
          </sqtm-core-entity-view-header>
          <div class="flex-row full-height full-width">
            <div class="flex-fixed-size side-bar">
              <div class="anchor-bar">
                <sqtm-core-anchor>
                  <sqtm-core-anchor-group [id]="'content'">
                    <sqtm-core-anchor-link
                      nz-tooltip
                      nzTooltipPlacement="right"
                      sqtmCoreDefaultAnchorLink
                      [id]="'information'"
                      [nzTooltipTitle]="
                        'sqtm-core.test-case-workspace.title.information'
                          | translate
                      "
                      [iconName]="'sqtm-core-requirement:information'"
                    >
                    </sqtm-core-anchor-link>
                    <sqtm-core-anchor-link
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [id]="'rate'"
                      [nzTooltipTitle]="
                        'sqtm-core.requirement-workspace.title.rate' | translate
                      "
                      [iconName]="'sqtm-core-requirement:coverage_indicators'"
                    >
                    </sqtm-core-anchor-link>
                    @if (
                      componentData.requirementVersion.highLevelRequirement
                    ) {
                      <sqtm-core-anchor-link
                        nz-tooltip
                        nzTooltipPlacement="right"
                        [id]="'linked-low-level-requirements'"
                        [nzTooltipTitle]="
                          'sqtm-core.requirement-workspace.title.low-level-requirement-version-link'
                            | translate
                        "
                        [iconName]="
                          'sqtm-core-requirement:linked_low_level_requirements'
                        "
                      >
                        @if (
                          requirementViewService.linkedLowLevelRequirementCount$
                            | async;
                          as linkedLowLevelRequirementCount
                        ) {
                          @if (linkedLowLevelRequirementCount > 0) {
                            <div class="anchor-counter">
                              <span>{{ linkedLowLevelRequirementCount }}</span>
                            </div>
                          }
                        }
                      </sqtm-core-anchor-link>
                    }
                    <sqtm-core-anchor-link
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [id]="'linked-test-case'"
                      [nzTooltipTitle]="
                        'sqtm-core.requirement-workspace.title.linked-test-case'
                          | translate
                      "
                      [iconName]="'sqtm-core-requirement:linked_test_cases'"
                    >
                      @if (
                        requirementViewService.verifyingTestCaseCount$ | async;
                        as verifyingTestCaseCount
                      ) {
                        @if (verifyingTestCaseCount > 0) {
                          <div class="anchor-counter">
                            <span>{{ verifyingTestCaseCount }}</span>
                          </div>
                        }
                      }
                    </sqtm-core-anchor-link>
                    <sqtm-core-anchor-link
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [id]="'requirement-version-links'"
                      [nzTooltipTitle]="
                        'sqtm-core.requirement-workspace.title.requirement-version-link'
                          | translate
                      "
                      [iconName]="'sqtm-core-requirement:requirements_link'"
                    >
                      @if (
                        requirementViewService.requirementVersionLinkCount$
                          | async;
                        as requirementVersionLinkCount
                      ) {
                        @if (requirementVersionLinkCount > 0) {
                          <div class="anchor-counter">
                            <span>{{ requirementVersionLinkCount }}</span>
                          </div>
                        }
                      }
                    </sqtm-core-anchor-link>
                  </sqtm-core-anchor-group>
                  <sqtm-core-anchor-group [id]="'history'">
                    <sqtm-core-anchor-link
                      nz-tooltip
                      nzTooltipPlacement="right"
                      [id]="'history'"
                      [nzTooltipTitle]="
                        'sqtm-core.requirement-workspace.title.modification-history'
                          | translate
                      "
                      [iconName]="'sqtm-core-requirement:history'"
                    >
                    </sqtm-core-anchor-link>
                  </sqtm-core-anchor-group>
                  @if (componentData.projectData.bugTracker) {
                    <sqtm-core-anchor-group [id]="'issues'">
                      <sqtm-core-anchor-link
                        class="position-relative"
                        nz-tooltip
                        nzTooltipPlacement="right"
                        [id]="'issues'"
                        [nzTooltipTitle]="
                          'sqtm-core.requirement-workspace.title.issues'
                            | translate
                        "
                        [iconName]="'sqtm-core-generic:issues'"
                      >
                        @if (
                          componentData.requirementVersion.nbIssues != null
                        ) {
                          @if (componentData.requirementVersion.nbIssues > 0) {
                            <div class="anchor-counter">
                              <span>{{
                                componentData.requirementVersion.nbIssues
                              }}</span>
                            </div>
                          }
                        } @else {
                          <sqtm-core-full-page-loading-icon
                            class="loading-icon"
                          ></sqtm-core-full-page-loading-icon>
                        }
                      </sqtm-core-anchor-link>
                    </sqtm-core-anchor-group>
                  }
                </sqtm-core-anchor>
              </div>
            </div>
            <div #content class="content-body full-height full-width">
              <router-outlet></router-outlet>
            </div>
          </div>
        </div>
      </div>
      <sqtm-core-attachment-drawer [canAttach]="canAttach(componentData)">
      </sqtm-core-attachment-drawer>
      @if (componentData.requirementVersion.uiState.openTestCaseTreePicker) {
        <sqtm-core-drawer
          [localTheme]="testCaseWorkspace"
          [isVisible]="
            componentData.requirementVersion.uiState.openTestCaseTreePicker
          "
          [titleKey]="'sqtm-core.tree-picker.test-case.title'"
          (close)="closeTestCasePicker()"
        >
          <i
            projection="icons"
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="fill"
            class="m-l-10 font-20-px current-workspace-main-color"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.tree-picker.test-case.requirement' | translate
            "
          ></i>
          @if (
            componentData.requirementVersion.uiState.openTestCaseTreePicker
          ) {
            <sqtm-core-test-case-picker
              [pickerPersistenceKey]="'bind-test-case-to-requirement'"
            >
            </sqtm-core-test-case-picker>
          }
        </sqtm-core-drawer>
      }
      @if (
        componentData.requirementVersion.uiState
          .openHighLevelRequirementChildrenTreePicker
      ) {
        <sqtm-core-drawer
          [localTheme]="requirementWorkspace"
          [isVisible]="
            componentData.requirementVersion.uiState
              .openHighLevelRequirementChildrenTreePicker
          "
          [titleKey]="'sqtm-core.tree-picker.requirement.title'"
          (close)="closeHighLevelRequirementChildrenPicker()"
        >
          <i
            projection="icons"
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="fill"
            class="m-l-10 font-20-px current-workspace-main-color"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.tree-picker.high-level-requirement.requirement-links'
                | translate
            "
          ></i>
          @if (
            componentData.requirementVersion.uiState
              .openHighLevelRequirementChildrenTreePicker
          ) {
            <sqtm-core-high-level-requirement-children-picker
              [pickerPersistenceKey]="
                'bind-requirement-to-high-level-requirement'
              "
            >
            </sqtm-core-high-level-requirement-children-picker>
          }
        </sqtm-core-drawer>
      }
      @if (componentData.requirementVersion.uiState.openRequirementTreePicker) {
        <sqtm-core-drawer
          [localTheme]="requirementWorkspace"
          [isVisible]="
            componentData.requirementVersion.uiState.openRequirementTreePicker
          "
          [titleKey]="'sqtm-core.tree-picker.requirement.title'"
          (close)="closeRequirementPicker()"
        >
          <i
            projection="icons"
            nz-icon
            nzType="sqtm-core-generic:help"
            nzTheme="fill"
            class="m-l-10 font-20-px current-workspace-main-color"
            nz-tooltip
            [nzTooltipTitle]="
              'sqtm-core.tree-picker.requirement.requirement-links' | translate
            "
          ></i>
          @if (
            componentData.requirementVersion.uiState.openRequirementTreePicker
          ) {
            <sqtm-core-requirement-picker
              [pickerPersistenceKey]="'bind-requirement-to-requirement'"
            >
            </sqtm-core-requirement-picker>
          }
        </sqtm-core-drawer>
      }
      <nz-dropdown-menu #actionMenu="nzDropdownMenu">
        <ul nz-menu [attr.data-test-menu-id]="'action-menu'">
          @if (this.showCreateNewVersionMenuItem()) {
            <li
              (click)="createNewRequirementVersion(componentData)"
              [attr.data-test-menu-item-id]="'create-new-requirement-version'"
              [nzDisabled]="!canCreateNewVersion(componentData)"
              nz-menu-item
            >
              {{ 'sqtm-core.generic.label.add-new-version' | translate }}
            </li>
          }
          @if (isConvertToHighLevelVisible(componentData, referentialData)) {
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="
                'convert-to-high-level-requirement'
              "
              [nzDisabled]="!canConvertToHighLevelOrStandard(componentData)"
              (click)="
                convertToHighLevelOrStandardRequirement(componentData, true)
              "
            >
              {{
                'sqtm-core.requirement-workspace.convert-to-high-level-requirement'
                  | translate
              }}
            </li>
          }
          @if (componentData.permissions.canExport) {
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'open-in-print-mode'"
              (click)="openInPrintMode(componentData)"
            >
              {{ 'sqtm-core.generic.label.print' | translate }}
            </li>
          }
          @if (isAiTestCaseGenerationVisible(componentData)) {
            <li
              nz-menu-item
              [attr.data-test-menu-item-id]="'ai-test-case-generation'"
              (click)="openTestCaseGenerationWithAiDialog(componentData)"
            >
              <div class="flex full-width align-items-center">
                <span>{{
                  'sqtm-core.requirement-workspace.generate-test-case-with-ai'
                    | translate
                }}</span>
                <i
                  nz-icon
                  nzType="sqtm-core-generic:erlenmeyer"
                  class="current-workspace-button align-center erlenmeyer-icon"
                  nz-tooltip
                  nzTooltipPlacement="topRight"
                  [nzTooltipTitle]="
                    'sqtm-core.generic.experimental-feature' | translate
                  "
                ></i>
              </div>
            </li>
          }
        </ul>
      </nz-dropdown-menu>
    } @else {
      <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
    }
  }
</sqtm-core-entity-view-wrapper>

<ng-template #loading>
  <sqtm-core-full-page-loading-icon></sqtm-core-full-page-loading-icon>
</ng-template>

<ng-template #lockedMilestoneMessage>
  {{ 'sqtm-core.entity.generic.milestone.locked' | translate }}
</ng-template>
